#include <avr/io.h>

.section .text

.global main
.org 0x00
main:
    ; PB2 on PORTB is output.
    ldi     R16, 0b0100
    out     _SFR_IO_ADDR(DDRB), R16
    ;out     _SFR_IO_ADDR(PORTB), R16    ; Set PB2 to HIGH

    ; Set CPP register, so we can change
    ; protected CLKPSR register
    ldi     R16, 0xD8
    out     _SFR_IO_ADDR(CCP), R16

    ; Internal 8MHz oscillator with 8 prescaller
    ; so we are running at 1MHz.
    ldi     R16, 0x04                   ; 1MHz
    out     _SFR_IO_ADDR(CLKPSR), R16

    ; Disable interrupts
    cli

loop:
    ldi     R16, 0x0F
    out     _SFR_IO_ADDR(PORTB), R16
    rcall   delay
    ldi     R16, 0x00
    out     _SFR_IO_ADDR(PORTB), R16
    rcall   delay
    rjmp    loop

delay:
    ldi     R17, 0xFF
dl1:
    ldi     R18, 0xFF
dl2:
    dec     R18
    brne    dl2
    dec     R17
    brne    dl1
    ret
.end
